#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include "mlm_download.h"
#include "mlm_string.h"
#include "mlm_file.h"
#include "mlm_utility.h"


/*****************************************************************/

int movienumber, movielist[50];

/*****************************************************************/

void check_all (GtkWidget *widget, gpointer data)
{
	if(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)))
		movienumber = movielist[atoi(data)];
}

/*****************************************************************/

int moviesearch(const char *p) {

	extern GtkWidget *main_window;
    FILE *f;
    char buf[1000];
    char moviename[150];
    char address[250], command[300], cookiepath[300], *main_index_dir;
    char *ptr;

    strcpy(moviename, p);

    movielist_str_edit(moviename);

	main_index_dir = calloc(60, sizeof(char));
	sprintf(main_index_dir, "%s/index", main_dir);

    //Cookie indirme
    sprintf(cookiepath, "%s/cookie.txt", main_index_dir);
    remove(cookiepath);
    remove(download_index_path);

    sprintf(address, "http://www.sinemalar.com/filmler/%s/", moviename);
    sprintf(command, "wget --cookies=on --keep-session-cookies --save-cookies='%s/cookie.txt' '%s' -P '%s'", main_index_dir, address, main_index_dir);
    system(command);

    //Cookie ile film indirme
    remove(download_index_path);
    sprintf(command, "wget --referer='%s' --cookies=on --load-cookies='%s/cookie.txt' '%s' -P '%s'", address, main_index_dir, address, main_index_dir);
    system(command);

    if ((f = fopen(download_index_path, "r")) == NULL) {
        printf("Cannot open file:%s\n", download_index_path);
        exit(EXIT_FAILURE);
    }

    //Bulunan filmler
    while (fgets(buf, 1000, f))
          if (ptr = strstr_dup(buf, "Filmler ~ <span class=\"gray\">", "</span>")) {

             int moviecount;

             moviecount = atoi(ptr);
             free(ptr);

             if (moviecount > 1) {
                 int k = 1, movienumber_chr_value;
             	 GtkDialog *choosemovie_dialog;
                 GtkWidget  *label, *hbox, *button;
                 char label_text[200], *movienumber_chr[51];

                 for(movienumber_chr_value = 1; movienumber_chr_value <= 50; ++movienumber_chr_value){
                 	movienumber_chr[movienumber_chr_value] = (char *)calloc(3, sizeof(char));
                 	sprintf(movienumber_chr[movienumber_chr_value], "%d", movienumber_chr_value );
                 }

              	choosemovie_dialog = gtk_dialog_new_with_buttons(
              			"Film Seçme",
              			GTK_WINDOW(main_window),
              			GTK_DIALOG_DESTROY_WITH_PARENT,
              			"Vazgeç",
              			GTK_RESPONSE_REJECT,
              			"İndir",
              			GTK_RESPONSE_ACCEPT,
              			NULL);
                  sprintf(label_text, "%s filmi için %d film bulundu", p, moviecount);

                  label = gtk_hseparator_new();
                  gtk_box_pack_start(GTK_BOX(choosemovie_dialog -> vbox), label, FALSE, FALSE, 0);

                  label = gtk_label_new(label_text);
                  gtk_box_pack_start(GTK_BOX(choosemovie_dialog -> vbox), label, FALSE, FALSE, 0);

                  label = gtk_hseparator_new();
                  gtk_box_pack_start(GTK_BOX(choosemovie_dialog -> vbox), label, FALSE, FALSE, 0);

                  button = gtk_radio_button_new(NULL);

                 while (fgets(buf, 1000, f)) {

                      if(strstr(buf, "commentsright")) {
                          fgets(buf, 1000, f);
                          if (ptr = strstr_dup(buf, "/\">", "</a>")) {
                              sprintf(label_text, "%d) %s\n", k, ptr);

                              hbox = gtk_hbox_new(FALSE, 0);
                              gtk_box_pack_start(GTK_BOX(choosemovie_dialog -> vbox), hbox, FALSE, FALSE, 0);
                              button = gtk_radio_button_new_with_label_from_widget (GTK_RADIO_BUTTON (button), label_text);
                              g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(check_all), (gpointer) movienumber_chr[k]);
                              gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);
                              free(ptr);
                          }
                          movielist[k++] = atoi(ptr = strstr_dup(buf, "film/", "/"));
                          free(ptr);
                      }
                 }

                 gtk_widget_show_all(GTK_WIDGET(choosemovie_dialog));
                 kill_process();
                 if((gtk_dialog_run(choosemovie_dialog)) == GTK_RESPONSE_REJECT){
                	 gtk_widget_destroy(GTK_WIDGET(choosemovie_dialog));
                	 return 0;
                 }
                 else
                	 gtk_widget_destroy(GTK_WIDGET(choosemovie_dialog));

             	char command[250];
             	sprintf(command, "/usr/share/mlm/dialog/mlm_show_dialog \"%s Filmi indiriliyor...\nLÜTFEN BEKKLEYİN!!!\"&", moviename);
             	system(command);

             }
             else if (moviecount == 1) {
                 while (fgets(buf, 1000, f))
                      if(strstr(buf, "commentsright")) {
                          fgets(buf, 1000, f);
                          movienumber = atoi(ptr = strstr_dup(buf, "film/", "/"));
                          free(ptr);
                      }
             }
             else {
            	kill_process();
          		GtkWidget *dialog;
          		dialog = gtk_message_dialog_new(GTK_WINDOW(main_window),
          		            GTK_DIALOG_DESTROY_WITH_PARENT,
          		            GTK_MESSAGE_WARNING,
          		            GTK_BUTTONS_OK,
          		            "Film bulunamadı!");

         		gtk_window_set_title(GTK_WINDOW(dialog), "Uyarı");
         		gtk_dialog_run(GTK_DIALOG(dialog));
         		gtk_widget_destroy(dialog);
                   return 0;
             }
        }

    fclose(f);

    //Film sayfasının indirilmesi
    system("clear");
    printf("Film bulundu, indiriliyor...\n\n");

    remove(download_index_path);
    sprintf(address, "http://www.sinemalar.com/film/%d/film/", movienumber);
    sprintf(command, "wget --referer=%s --cookies=on --load-cookies='%s/cookie.txt' %s -P '%s'", address, main_index_dir, address, main_index_dir);
    puts(command);
    system(command);
    remove(cookiepath);

    return 1;
}


/*****************************************************************/

