#include "mlm_string.h"

#include <string.h>

/*****************************************************************/

char *str_insert_all(char *dest, char *changestr, char *insertstr)
{
    int i;
    char *pdest = dest;
    int len_cstr, len_instr;

    len_cstr = strlen(changestr);
    len_instr = strlen(insertstr);

    for(i = 0; pdest[i] != '\0'; i++)
        ;

    if (len_cstr == len_instr)
        while(pdest != NULL)
            if ((pdest = strstr(pdest ,changestr)) != NULL)
                strncpy(pdest, insertstr, len_instr);
            
    
    if (len_cstr > len_instr)
     	while(pdest != NULL)
            if ((pdest = strstr(pdest ,changestr)) != NULL) {
                strncpy(pdest, insertstr, len_instr);
                strcpy(pdest + len_instr, pdest + len_cstr);
            }

    return dest;

}

/*****************************************************************/

char *str_insert(char *dest, char *changestr, char *insertstr)
{
    char *pdest = dest;
    char *ptemp;
    int len_cstr, len_instr;

    len_cstr = strlen(changestr);
    len_instr = strlen(insertstr);

    if (len_cstr == len_instr)
        if (pdest = strstr(pdest ,changestr)) {
            strncpy(ptemp, insertstr, len_instr);
            return dest;
        }

    if (len_cstr > len_instr)
        if (ptemp = strstr(pdest ,changestr)) {
            strncpy(ptemp, insertstr, len_instr);
            strcpy(ptemp + len_instr, ptemp + len_cstr);
            return dest;
        }
}



/*****************************************************************/

char *strstr_dup(const char *str, const char *start, const char *end)
{
    char *pStart, *pEnd;
    int len, len_start;
    char *temp;

    len_start = strlen(start);

    if (!(pStart  = strstr(str, start)))
        return NULL;

    if (!(pEnd = strstr(pStart + len_start, end)))
        return NULL;


   len = pEnd - pStart - len_start;

   temp = (char *)malloc((len + 1) * sizeof(char));

   strncpy(temp, pStart + len_start, len);
   temp[len] = '\0';

   return temp;
}

/*****************************************************************/

char *str_remove(char *dest, char firstchr, char secondchr)
{
    char *pdest = dest;
    char *pfirst, *psecond;

    pfirst = strchr(pdest, firstchr);

	if (psecond = strchr(pdest, secondchr)) {
		strncpy(pfirst, psecond + 1, strlen(psecond + 1) + 1);
		return pdest;
	}

	return pdest;
}

/*****************************************************************/

void remove_lastchar(char *address)
{
	int k = strlen(address);
	address[k - 1] = '\0';
}

/*****************************************************************/
int compare_wh_case(const char *a, const char *b)
{
   int i, return_value;
   char *temp_a, *temp_b;

   temp_a = (char *)calloc(100, sizeof(char));
   temp_b = (char *)calloc(30, sizeof(char));

   for(i = 0; a[i] != '\0'; ++i){
      if(a[i] >= 'a' && a[i] <= 'z')
          temp_a[i] = a[i] - 'a' + 'A';
      else
          temp_a[i] = a[i];
   }
   temp_a[i+1] = '\0';

   for(i = 0; i < strlen(b); ++i){
      if(b[i] >= 'a' && b[i] <= 'z')
          temp_b[i] = b[i] - 'a' + 'A';
      else
          temp_b[i] = b[i];
   }
   temp_b[i+1] = '\0';

   if(strstr(temp_a, temp_b))
       return_value = 1;
   else
       return_value = 0;

   free(temp_a);
   free(temp_b);

   return return_value;
}

/*****************************************************************/

